Bug 1726843 - Review Request: dynaconf - A dynamic configurator for python projects
Summary: Review Request: dynaconf - A dynamic configurator for python projects
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1726742
Blocks: 1674656
TreeView+ depends on / blocked
 
Reported: 2019-07-03 20:52 UTC by David Moreau Simard
Modified: 2020-05-19 10:22 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-05-19 10:22:05 UTC
Type: ---
zebob.m: fedora-review+


Attachments (Terms of Use)

Description David Moreau Simard 2019-07-03 20:52:26 UTC
Spec URL: https://github.com/dmsimard/dynaconf-distgit/blob/master/dynaconf.spec
SRPM URL: https://github.com/dmsimard/dynaconf-distgit/raw/master/dynaconf-2.0.3-1.fc30.src.rpm
Description: dynaconf is a layered configuration system for Python applications with strong support for 12-factor applications and extensions for Flask and Django.
Fedora Account System Username: dmsimard

Comment 1 Miro Hrončok 2019-07-03 21:36:43 UTC
Please make sure the links here are to the actual content and not HTML pages. FedoraReview tries to download them and fails.

Comment 2 David Moreau Simard 2019-07-04 14:17:26 UTC
Spec URL: https://raw.githubusercontent.com/dmsimard/dynaconf-distgit/master/dynaconf.spec
SRPM URL: https://github.com/dmsimard/dynaconf-distgit/raw/master/dynaconf-2.0.3-1.fc30.src.rpm
Description: dynaconf is a layered configuration system for Python applications with strong support for 12-factor applications and extensions for Flask and Django.
Fedora Account System Username: dmsimard

Comment 3 Miro Hrončok 2019-07-09 18:28:06 UTC
Various notes about the spec:



Requires:       python3-box
Requires:       python3-click
Requires:       python3-dotenv
Requires:       python3-toml
Requires:       python3-pyyaml

Is the automatic dependency generator not useful here?

---



%{python3_sitelib}/%{srcname}-*.egg-info

The setup.py has:

try:
    from setuptools import setup, find_packages
except ImportError:
    from distutils.core import setup, find_packages

I consider this combination quite dangerous, because based on the presence of setuptools in the buildroot, either distutils or setuptools will be used and %{python3_sitelib}/%{srcname}-*.egg-info will either be a file or directory. Updates between those two are problematic, see https://docs.fedoraproject.org/en-US/packaging-guidelines/Directory_Replacement/

As a precaution I suggest doing the following:

 1) BuildRequire python3-setuptools explicitly
 2) add a trailing slash to %{python3_sitelib}/%{srcname}-*.egg-info/ -> this will make sure the build fails if it is not a directory
 3) (optional) also add the slash to %{python3_sitelib}/%{srcname}/ for consistency with 2) and better readability

---



Summary:        dynaconf is a dynamic configurator for python projects
->
Summary:        Dynaconf is a dynamic configurator for Python projects

---



%global common_desc \
dynaconf is a layered configuration system for Python applications with strong \
support for 12-factor applications and extensions for Flask and Django
->
%global common_desc \
Dynaconf is a layered configuration system for Python applications with strong \
support for 12-factor applications and extensions for Flask and Django.

Comment 4 David Moreau Simard 2019-07-10 15:52:39 UTC
(In reply to Miro Hrončok from comment #3)
> Various notes about the spec: 
> 
> Requires:       python3-box
> Requires:       python3-click
> Requires:       python3-dotenv
> Requires:       python3-toml
> Requires:       python3-pyyaml
> 
> Is the automatic dependency generator not useful here?

Thanks, I removed the Requires and the automatic dependency generator works as intended.

> 
> %{python3_sitelib}/%{srcname}-*.egg-info
> 
> The setup.py has:
> 
> try:
>     from setuptools import setup, find_packages
> except ImportError:
>     from distutils.core import setup, find_packages
> 
> I consider this combination quite dangerous, because based on the presence
> of setuptools in the buildroot, either distutils or setuptools will be used
> and %{python3_sitelib}/%{srcname}-*.egg-info will either be a file or
> directory. Updates between those two are problematic, see
> https://docs.fedoraproject.org/en-US/packaging-guidelines/
> Directory_Replacement/
> 
> As a precaution I suggest doing the following:
> 
>  1) BuildRequire python3-setuptools explicitly
>  2) add a trailing slash to %{python3_sitelib}/%{srcname}-*.egg-info/ ->
> this will make sure the build fails if it is not a directory
>  3) (optional) also add the slash to %{python3_sitelib}/%{srcname}/ for
> consistency with 2) and better readability
> 

Good catch. I've made the suggested adjustment and it builds fine.
 
> Summary:        dynaconf is a dynamic configurator for python projects
> ->
> Summary:        Dynaconf is a dynamic configurator for Python projects

Done

> %global common_desc \
> dynaconf is a layered configuration system for Python applications with
> strong \
> support for 12-factor applications and extensions for Flask and Django
> ->
> %global common_desc \
> Dynaconf is a layered configuration system for Python applications with
> strong \
> support for 12-factor applications and extensions for Flask and Django.

Done

Comment 5 David Moreau Simard 2019-07-10 15:53:09 UTC
Spec URL: https://raw.githubusercontent.com/dmsimard/dynaconf-distgit/master/dynaconf.spec
SRPM URL: https://github.com/dmsimard/dynaconf-distgit/raw/master/dynaconf-2.0.3-1.fc30.src.rpm
Description: dynaconf is a layered configuration system for Python applications with strong support for 12-factor applications and extensions for Flask and Django.
Fedora Account System Username: dmsimard

Comment 6 Robert-André Mauchin 🐧 2019-07-13 17:54:21 UTC
 - Don't repeat the name in the summary:

Summary:        Dynamic configurator for python projects


Package approved. Please fix the aforementioned issue before import.



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "Expat License". 44 files have unknown
     license. Detailed output of licensecheck in
     /home/bob/packaging/review/dynaconf/review-dynaconf/licensecheck.txt
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-dynaconf-2.0.3-1.fc31.noarch.rpm
          dynaconf-2.0.3-1.fc31.src.rpm
python3-dynaconf.noarch: W: spelling-error Summary(en_US) configurator -> configuration, confiscator, figuration
python3-dynaconf.noarch: W: no-manual-page-for-binary dynaconf
dynaconf.src: W: spelling-error Summary(en_US) configurator -> configuration, confiscator, figuration
dynaconf.src: W: name-repeated-in-summary C Dynaconf
2 packages and 0 specfiles checked; 0 errors, 4 warnings.

Comment 7 Mohan Boddu 2019-07-19 16:23:41 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/dynaconf


Note You need to log in before you can comment on or make changes to this bug.